<div id="header">
  <app-header></app-header>
</div>
<div class="container-fluid">
  <div id="content-wrapper" class="d-flex flex-row">
    <div id="sidebar"><app-sidebar></app-sidebar></div>
    <div id="main-container-gestionnaire-roles" class="container-fluid d-flex flex-column">
      <div id="title-container" class="container-fluid d-flex justify-content-between align-items-center p-4">
        <div class="dashboard-title d-flex flex-row align-items-center  p-5">
          <span><h1>GESTIONNAIRE DE TYPES D'ERREURS</h1></span>
        </div>
        <app-add-type-erreur-popup></app-add-type-erreur-popup>
      </div>
      <div class="accordion accordion-flush" id="accordionFlushExample">
        <div class="accordion-item "
             *ngFor="let type of typeErreurs; index as index "
             id="{{ type.id }}}">
          <h2 class="accordion-header" id="flush-heading{{ type.id }}">
            <button class="accordion-button collapsed d-flex flex-row justify-content-between align-items-center "
                    type="button" data-bs-toggle="collapse"
                    [attr.data-bs-target]="'#flush-collapse' +
                    type.id " aria-expanded="false"
                    [attr.aria-controls]="'flush-collapse' +
                    type.id ">
              <div class="d-flex flex-row flex-grow-1 d-flex align-items-center">
                <span *ngIf="!type.archive" class="actif status d-flex align-items-center" (click)="onDelete($event, type)">actif</span>
                <span *ngIf="type.archive" class="inactif status d-flex align-items-center" (click)="onDelete($event, type)">inactif</span>
                <span *ngIf="type.priorite && type.priorite == 1"
                      style="background-color: red"
                      class="priorite status d-flex align-items-center"
                      (click)="onSetPriorite($event, type)">urgent</span>
                <span *ngIf="type.priorite && type.priorite == 2"
                      style="background-color: orange"
                      class="priorite status d-flex align-items-center"
                      (click)="onSetPriorite($event, type)">important</span>
                <span *ngIf="type.priorite && type.priorite == 3"
                      style="background-color: yellowgreen"
                      class="priorite status d-flex align-items-center"
                      (click)="onSetPriorite($event, type)">standard</span>
                <span *ngIf="type.priorite && type.priorite == 4"
                      style="background-color: yellow"
                      class="priorite status d-flex align-items-center"
                      (click)="onSetPriorite($event, type)">optionnel</span>
                <span *ngIf="!type.priorite"
                      style="background-color: grey"
                      class="priorite status d-flex align-items-center"
                      (click)="onSetPriorite($event, type)">indéterminée</span>
                <span *ngIf="type.niveau && type.niveau == 1"
                      [style.background]="type.couleur"
                      class="niveau status d-flex align-items-center"
                      (click)="onSetNiveau($event, type)">critique</span>
                <span *ngIf="type.niveau && type.niveau == 2"
                      [style.background]="type.couleur"
                      class="niveau status d-flex align-items-center"
                      (click)="onSetNiveau($event, type)">modéré</span>
                <span *ngIf="type.niveau && type.niveau == 3"
                      [style.background]="type.couleur"
                      class="niveau status d-flex align-items-center"
                      (click)="onSetNiveau($event, type)">standard</span>
                <span *ngIf="type.niveau && type.niveau == 4"
                      [style.background]="type.couleur"
                      class="niveau status d-flex align-items-center"
                      (click)="onSetNiveau($event, type)">faible</span>
                <span *ngIf="!type.niveau"
                      class="niveau status d-flex align-items-center"
                      style="background-color: grey"
                      (click)="onSetNiveau($event, type)">indéterminé</span>
                <!--<span class="plan-title d-flex align-items-center">{{ (groupe.nom.length>25)? (groupe.nom | slice:0:25)+'...':(groupe.nom) }}</span>-->
                <span class="plan-title d-flex align-items-center">{{ type.nom }}</span>
              </div>
              <div>
                <span class="edit" (click)="onClick($event, type)"><i class="fa-solid fa-pen" aria-hidden="true"></i></span>
                <!-- TODO: add link to dashboard-group: (click)="redirect('dashboard-groupe', groupe)"-->
                <span id="eye-button" (click)="navigateTo(type)">
                  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" (click)="navigateTo(type)">
                    <g>
                      <g fill="#231F20">
                        <path d="m34,256l26.2,26.2c108,108 283.7,108 391.7,0l26.1-26.2-26.2-26.2c-108-108-283.7-108-391.7,0l-26.1,26.2zm222,126.2c-75.8,0-151.6-28.9-209.3-86.6l-32.9-32.9c-3.7-3.7-3.7-9.7 0-13.5l32.9-32.9c115.4-115.4 303.2-115.4 418.6,0l32.9,32.9c3.7,3.7 3.7,9.7 0,13.5l-32.9,32.9c-57.7,57.7-133.5,86.6-209.3,86.6z"/>
                        <path d="m256,183.5c-40,0-72.5,32.5-72.5,72.5s32.5,72.5 72.5,72.5c40,0 72.5-32.5 72.5-72.5s-32.5-72.5-72.5-72.5zm0,164c-50.5,0-91.5-41.1-91.5-91.5 0-50.5 41.1-91.5 91.5-91.5s91.5,41.1 91.5,91.5c0,50.5-41,91.5-91.5,91.5z"/>
                      </g>
                    </g>
                  </svg>
                </span>
              </div>
            </button>
          </h2>
          <div id="flush-collapse{{ type.id }}" class="accordion-collapse collapse"
               [attr.aria-labelledby]="'flush-heading' +
               type.id "
               data-bs-parent="#accordionFlushExample">
            <div class="accordion-body ">
              <h3>DETAILS</h3>
              <h4>{{ type.nom }}</h4>
              <p>
                {{ type.details }}
              </p>
            </div>
            <div class="accordion-body-bottom "></div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<!-- modal -->
<!-- Modal EDIT groupe-->
<div class="modal" id="myModal" [style.display]="showModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Détails du Groupe du Type d'erreur : {{editType?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('editModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #editForm="ngForm" >
          <div class="form-group">
            <input
                   type="hidden"
                   ngModel="{{editType?.id}}"
                   name="id"
                   id="id"
            />
            <input
              type="hidden"
              ngModel="{{editType?.priorite}}"
              name="priorite"
              id="priorite"
            />
            <input
              type="hidden"
              ngModel="{{editType?.niveau}}"
              name="niveau"
              id="niveau"
            />
            <input
              type="hidden"
              ngModel="{{editType?.couleur}}"
              name="couleur"
              id="couleur"
            />
            <input
              type="hidden"
              ngModel="{{editType?.archive}}"
              name="archive"
              id="archive"
            />
            <label class="mb-1" for="nom">Intitulé</label>
            <input
                   type="text"
                   ngModel="{{editType?.nom}}"
                   id="nom"
                   name="nom"
                   class="form-control mb-2"
            />
          </div>
          <div class="form-group">
            <label class="mb-1" for="details">Détails</label>
            <textarea
              class="form-control mb-2"
              ngModel="{{editType?.details}}"
              id="details"
              name="details"
            ></textarea>
          </div>
          <div class="mt-3 mb-2">
            <button class="btn btn-primary w-100" (click)="onSubmit(editForm.value)" [disabled]="editForm.invalid">Sauvegarder</button>
          </div>
          <div class="mt-2 mb-2">
            <button class="btn btn-secondary w-100" type="reset" (click)="hide('editModal')">Annuler</button>
          </div>
        </form>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal DELETE Plan-->
<div class="modal" id="deleteModal" [style.display]="showDeleteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Archiver : {{deleteType?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('deleteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #deleteForm="ngForm" >
          <div class="form-group">
            <p *ngIf="deleteType?.archive == true" class="mt-3 mb-5" >Vous êtes sur le point d'activer le type d'erreur {{deleteType?.nom}}. <br/><br/>
              Êtes-vous sûr.e de vouloir continuer ?</p>
            <p *ngIf="deleteType?.archive == false" class="mt-3 mb-5" >Vous êtes sur le point de désactiver le type d'erreur {{deleteType?.nom}}. <br/><br/>
              Êtes-vous sûr.e de vouloir continuer ?</p>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button *ngIf="deleteType?.archive == true" class="btn btn-danger w-100" (click)="onArchiveType(deleteType)" data-dismiss="modal">Activer</button>
          <button *ngIf="deleteType?.archive == false" class="btn btn-danger w-100" (click)="onArchiveType(deleteType)" data-dismiss="modal">Désactiver</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal SHOW PRIORITE -->
<div class="modal" id="setPrioriteModal" [style.display]="showPrioriteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Niveau de criticité : {{setPriorite?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('setPrioriteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #prioriteForm="ngForm" >
          <div class="form-group">
            <label for="priorite" class="w-100 mb-1" >Priorite</label>
            <select ngModel="{{editType?.priorite}}" name="priorite" id="priorite" class="w-100">
              <option value="" [selected]>Choisissez une priorité</option>
              <option value=1 [selected]="editType?.priorite == 1">urgent</option>
              <option value=2 [selected]="editType?.priorite == 2">important</option>
              <option value=3 [selected]="editType?.priorite == 3">standard</option>
              <option value=4 [selected]="editType?.priorite == 4">optionnel</option>
            </select>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button class="btn btn-primary w-100" (click)="onModifyPriorite(prioriteForm.value)" data-dismiss="modal">Enregistrer</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>


<!-- Modal SHOW PRIORITE -->
<div class="modal" id="setNiveauModal" [style.display]="showNiveauModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Définir le niveau : {{setNiveau?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('setNiveauModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #niveauForm="ngForm" >
          <div class="form-group">
            <label for="niveau" class="w-100 mb-1" >Niveau</label>
            <select [ngModel]="setNiveau?.niveau" name="niveau" id="niveau" class="w-100" >
              <option value="" [selected]>Niveau de criticité</option>
              <option value=1 [selected]="setNiveau?.niveau == 1">critique</option>
              <option value=2 [selected]="setNiveau?.niveau == 2">modéré</option>
              <option value=3 [selected]="setNiveau?.niveau == 3">standard</option>
              <option value=4 [selected]="setNiveau?.niveau == 4">faible</option>
            </select>
          </div>
          <div id="color-picker-container" class="form-group" >
            <label class="mb-1 me-2 w-100" for="couleur">Couleur :</label>
            <input name="couleur" id="couleur"
                   [style.background]="color1"
                   [(colorPicker)]="color1"
                   (colorPickerClose)="onEventLog('colorPickerClose', $event)"/>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button class="btn btn-primary w-100" (click)="onModifyNiveau(niveauForm)" data-dismiss="modal">Enregistrer</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>
